package cn.bunny.domain.dto;

import cn.hutool.core.date.DateUtil;
import com.fasterxml.jackson.annotation.JsonFormat;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.io.Serializable;
import java.util.Date;

@Data
@AllArgsConstructor
@NoArgsConstructor
public class GoviewProjectDto implements Serializable {
    private static final long serialVersionUID = 1L;

    @ApiModelProperty(value = "主键")
    private String id;

    @ApiModelProperty(value = "项目名称")
    private String projectName;

    @ApiModelProperty(value = "项目状态[-1未发布,1发布]")
    private Integer state;
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    @ApiModelProperty(value = "创建时间")
    private Date createTime;

    @ApiModelProperty(value = "创建人id")
    private String createUserId;

    @ApiModelProperty(value = "删除状态[1删除,-1未删除]")
    private Integer isDelete;

    @ApiModelProperty(value = "首页图片")
    private String indexImage;

    @ApiModelProperty(value = "项目介绍")
    private String remarks;
    private String content;

    @JsonProperty("id")
    public String getId() {
        return id;
    }

    @JsonProperty("projectName")
    public String getProjectName() {
        return projectName;
    }

    @JsonProperty("state")
    public Integer getState() {
        return state;
    }

    @JsonProperty("createTime")
    public Date getCreateTime() {
        return createTime;
    }

    @JsonProperty("createUserId")
    public String getCreateUserId() {
        return createUserId;
    }

    @JsonProperty("isDelete")
    public Integer getIsDelete() {
        return isDelete;
    }

    @JsonProperty("indexImage")
    public String getIndexImage() {
        return indexImage;
    }

    @JsonProperty("remarks")
    public String getRemarks() {
        return remarks;
    }

    public String dateToStringConvert(Date date) {
        if (date != null) {
            return DateUtil.format(date, "yyyy-MM-dd HH:mm:ss");
        }
        return "";
    }
}